--- fvwm/fvwm2.man.orig	Thu Aug  7 23:51:54 1997
+++ fvwm/fvwm2.man	Sat Oct  4 16:30:29 1997
@@ -343,6 +343,33 @@
 exercise for the user to decide which function make sense for
 initialization and which ones make sense for run-time.
 
+.SH INTERNATIONALIZATION
+If you have applied patch named PATCH.I18N, fvwm (and modules)
+are using X11 internationalization.
+
+At first, you should use I18N fvwm and modules, of course. You
+can get patch from fvwm-users-jp-kits. See \fIABOUT FVWM-USERS-JP-KITS\fP
+section for more detail.
+
+Using i18n-fvwm is almost same as original fvwm, if you do not
+set the environment variable $LC_CTYPE (or $LANG). If you set to
+proper value (which is environment and character code dependant),
+i18n-fvwm's extended feature described below is available.
+
+.RS
+To display proper character, you can specify FONTSET instead of FONT
+to 4th argument of MenuStyle and argument of IconFont, WindowFont,
+AddToDecor's WindowFont decoration, *FvwmButtonFont, *FvwmFormFont,
+*FvwmFormButtonFont, *FvwmFormInputFont,
+*FvwmIconBoxFont, *FvwmIconMan[id*]*font, *FvwmIdentFont, *FvwmPagerFont,
+*FvwmPagerSmallFont and *FvwmWinListFont.
+
+After fontset is set, you may write (to $HOME/.fvwmrc or whatever
+initialize file) non-ASCII character to menu label, FvwmPager's desktop name,
+and so on. Window title or icon name is also displayed if it is
+specified as compound-text (or of course, Latin-1).
+.RE
+
 .SH BUILT IN FUNCTIONS
 \fIFvwm\fP supports a set of built-in functions which can be bound to
 keyboard or mouse buttons.  If fvwm expects to find a built-in function
@@ -1887,6 +1914,93 @@
 You may need to quit on each screen to quit from the X session
 completely.
 
+
+.SH ABOUT FVWM-USERS-JP-KITS
+
+Fvwm-users-jp-kits is a collection of materials distributed by
+"Fvwm Users' Mailing List in Japan (fvwm-users-jp)" mailing list.
+Fvwm-users-jp-kits contains feature enhancement patch, fvwm manual 
+and FAQ list in Japanese, helpful tools for fvwm family, etc...
+
+Fvwm-users-jp-kits is available from
+<URL:ftp://ftp.ics.es.osaka-u.ac.jp/pub/CFAN/fvwm-users-jp/kits;type=d>
+or its mirror or copy. Try archie.
+
+.SH NEW FEATURES IN FVWM-USERS-JP-KITS
+
+If all of patches from fvwm-users-jp-kits are applied to fvwm and modules,
+following features are available.
+
+.RS
+Fvwm can send its version string to modules. Kits-enhanced FvwmIdent
+use this information to display fvwm's version.
+
+When you make ~/new.xinitrc by FvwmSave, make sure to copy ~/.xinitrc
+from first line to the line 
+.EX
+# DO NOT DELETE THIS LINE - FvwmSave depend on it.
+.EE
+
+FvwmSaveDesk is smarter to handle title-changed-?term.
+
+WindowList arrangement is fixed by window-invoked order (CAUTION: if this
+patch is applied, you may confuse the behavior of FlipFocus).
+
+Fvwm and modules are using X11 internationalization
+when they compiled with -DI18N in OPTION_DEFINES (see Fvwm.tmpl).
+If you set the environment variable $LC_CTYPE or $LANG,
+you may specify fontSet instead of fontname and use non-ASCII character.
+See \fIINTERNATIONALIZATION\fP section for more detail.
+
+Following built-in functions have been added or changed:
+.RS
+.IP "Desk"
+Now Desk built-in function allows TWO or THREE argument.
+You can set following character(s) to the third
+argument of Desk.
+.RS
+.TP
+.B V
+Save current viewport location of desktop before jump-desktop, and load
+viewport location of desktop (if any).
+.TP
+.B P
+Save current pointer location of desktop before jump-desktop, and load
+pointer location of desktop (if any).
+.PP
+.RE
+Both P and V can be specified (i.e., write down 
+.I PV
+or
+.I VP
+as the third argument), but only
+.B P
+is not allowed. Of course this enhancement is upper-compatible, so
+if third argument is not specified, no enhancement will work.
+
+.IP "TogglePage"
+Temporarily disables edge scrolling. Edge scrolling can be re-enabled
+by calling this again.
+
+.IP "Restart  \fIWindowManagerName\fP [ \fIarguments\fP ]"
+You should specify \fIarguments\fP for WindowManagerName.
+No default arguments (current arguments of fvwm running) is used.
+
+.IP "Style \fIwindowname\fP Icon"
+Option "Icon" lets you specify command instead of filename, i.e.,
+.EX
+Style "*" Icon "unknown.gif|giftoppm %s | ppmtoxpm"
+.EE
+will work (command should generate XPM format data to stdout).
+
+.IP "Style \fIwindowname\fP SmartPlacement"
+Consider "desktop which the window should be mapped" instead of "current desktop". 
+
+.IP "WindowList \fIopt\fP"
+New option \fIForcePopup\fP is added.
+If set, WindowList tend to use "popup" manner, instead of "sticky manner.
+.RE
+.RE
 
 .SH BUGS
 As of fvwm 0.99 there were exactly 39.342 unidentified bugs.
