/*
From:        Karsten Jensen <kbwj@diku.dk>
To:          lesstif@hungry.com
Subject:     Re: FileSelection patch
Date:        Mon, 29 Jun 1998 16:26:12 +0000

Rick Scott wrote:
> 
> I have to disagree with the changes to FileSB.c.  As you click the mouse
> in the various elements the default button does not change, hence the use
> of the dynamic default button.  The default button remains the same only the
> result of pressing return changes.  If the problem is anywhere I suspect it
> is in FileSB.c, since it is the only widget with this behaviour.  Any of the
> other dialogs pressing return will activate the default button.  Only
> FileSB does not always press the default button when return is pressed.



Rick, try this little program.

Karsten

*/

/*
 * test/Xm/filesb/test1.c - print value of FileSB resources from a
callback
 * $Id: test10.c,v 1.1 1998/06/30 23:02:13 rwscott Exp $
 */
#include <Xm/Xm.h>
#include <Xm/FileSBP.h>
#include <stdio.h>

void
cb(Widget w, XtPointer a, XtPointer b) {
    Widget fs = (Widget) a;
    Widget default_button;

    XtVaGetValues(fs, XmNdefaultButton, &default_button, NULL);
    printf("%s The name of the default_button is now %s %s\n", XtName(w),
	   XrmQuarkToString(default_button->core.xrm_name), XtName(default_button));


}

int
main(int argc, char **argv)
{
  XtAppContext app;
  Widget toplevel, box, filter_text, text, list, dir_list;

  toplevel = XtVaAppInitialize(&app, "listTest", NULL, 0,
 		               &argc, argv, NULL, NULL);

  box = XtVaCreateManagedWidget("Box", xmFileSelectionBoxWidgetClass,
toplevel,
				XmNdialogType, XmDIALOG_FILE_SELECTION, NULL);

  XtAddCallback(box, XmNfocusCallback, cb, box);
  filter_text = XmFileSelectionBoxGetChild(box, XmDIALOG_FILTER_TEXT);
  XtAddCallback(filter_text, XmNfocusCallback, cb, box);
  text = XmFileSelectionBoxGetChild(box, XmDIALOG_TEXT);
  XtAddCallback(text, XmNfocusCallback, cb, box);
  dir_list = XmFileSelectionBoxGetChild(box, XmDIALOG_DIR_LIST);
  XtAddCallback(dir_list, XmNbrowseSelectionCallback, cb, box);
  list = XmFileSelectionBoxGetChild(box, XmDIALOG_LIST);
  XtAddCallback(list, XmNbrowseSelectionCallback, cb, box);

  XtAddCallback(box, XmNokCallback, cb, NULL);

  XtManageChild(box);

  XtRealizeWidget(toplevel);
  XtAppMainLoop(app);
  exit(0);
}

