/* test of selection boxes */

#include <Xm/Xm.h>
#include <Xm/PushBP.h>
#include <Xm/MessageB.h>

Widget toplevel, box, push;
XtAppContext	app_context;

void FlushQueue(void)
/*- 
  flush all events out of the event queue
-*/
{
    XtInputMask m;

    XFlush(XtDisplay(toplevel));
    while ((m = XtAppPending(app_context)))
	XtAppProcessEvent(app_context, m);
    XmUpdateDisplay(toplevel);
}



void Push(Widget w, XtPointer client, XtPointer call)
{
	Widget	dialog = (Widget)client;
	XmString xmstr;

	XtManageChild(dialog);
	FlushQueue();
	FlushQueue();
	sleep(1);

	xmstr=XmStringCreateSimple("I said 'Yow, buddy!'");
	XtVaSetValues(dialog,
		      XmNmessageString, xmstr,
		      NULL);
	XmStringFree(xmstr);
	FlushQueue();
	FlushQueue();
	sleep(1);

	xmstr=XmStringCreateSimple("Hey, you!  I said 'Yow, buddy!'");
	XtVaSetValues(dialog,
		      XmNmessageString, xmstr,
		      NULL);
	XmStringFree(xmstr);
	FlushQueue();
	FlushQueue();
	sleep(1);

	xmstr=XmStringCreateSimple("Did you hear me?  I said 'Yow, buddy!'");
	XtVaSetValues(dialog,
		      XmNmessageString, xmstr,
		      NULL);
	XmStringFree(xmstr);
	FlushQueue();
	FlushQueue();
	sleep(1);
}

int
main(int argc, char **argv)
{
	XtAppContext	app;
	XmString	xms;
	Arg		args[3];
	int		nargs;

	toplevel = XtVaAppInitialize(&app, "listTest", NULL, 0,
			       &argc, argv, NULL, NULL);

	app_context=app;
	push = XmCreatePushButton(toplevel, "push", NULL, 0);
	XtVaSetValues(push,
			XtVaTypedArg, XmNlabelString, XtRString, "Push me !", 9,
		NULL);

	nargs=0;
	xms = XmStringCreateSimple("Yow, buddy");
	XtSetArg(args[nargs], XmNmessageString, xms); nargs++;
	box = XmCreateQuestionDialog(toplevel, "Box", args, nargs);

	XtAddCallback(push, XmNactivateCallback, Push, box);

	XtManageChild(push);

	XtRealizeWidget(toplevel);

	/*XdbPrintTree(toplevel);*/
	XtAppMainLoop(app);
	exit(0);
}
